!! hello_world_mpi.f90

      PROGRAM hello_world_mpi
          IMPLICIT NONE
          INCLUDE "mpif.h"

          INTEGER :: number_of_processes, my_rank
          INTEGER :: mpi_error_code

! ....... Start up MPI.

          CALL MPI_Init(mpi_error_code)

! ....... Query this MPI process's rank.

          CALL MPI_Comm_size(MPI_COMM_WORLD, number_of_processes,      &
      &            mpi_error_code)

! ....... Query the number of MPI processes in this run.

          CALL MPI_Comm_rank(MPI_COMM_WORLD, my_rank,                  &
      &            mpi_error_code)

! ....... Output to stdout the message from this rank.

          PRINT *, my_rank, " of ", number_of_processes,               &
      &       ": Hello, world!"

! ....... Shut down MPI.

          CALL MPI_Finalize(mpi_error_code)

      END PROGRAM hello_world_mpi

