
/* nbody_particle.h */

#ifndef nbody_particle_h
#define nbody_particle_h

#define first_particle_component_index   0
#define position_x_index                 first_particle_component_index
#define position_y_index                 (position_x_index + 1)
#define position_z_index                 (position_y_index + 1)
#define velocity_x_index                 (position_z_index + 1)
#define velocity_y_index                 (velocity_x_index + 1)
#define velocity_z_index                 (velocity_y_index + 1)
#define mass_index                       (velocity_z_index + 1)
#define last_particle_component_index    mass_index
#define number_of_particle_components                                     \
                                         (last_particle_component_index - \
                                          first_particle_component_index + 1)

typedef float Particle[number_of_particle_components];
typedef Particle* ParticlePtr;
typedef Particle* ParticleArray;

#include "nbody_force.h"

extern ParticleArray ParticleArray_construct(int number_of_particles);
extern ParticleArray ParticleArray_destruct(
                         ParticleArray this_particle_array,
                         int number_of_particles);
extern void ParticleArray_initialize(
                ParticleArray this_particle_array,
                int number_of_particles,
                float domain_size_x,
                float domain_size_y,
                float domain_size_z,
                float mass_maximum);
extern void ParticleArray_move(
                ParticleArray this_particle_array,
                ForceArray this_total_force_array,
                int number_of_particles, float time_interval);

extern void ParticleArray_output(
                char* base_filename,
                ParticleArray this_particle_array,
                int   number_of_particles,
                int   timestep,
                int   number_of_timesteps,
                int   timesteps_between_outputs,
                float domain_size_x,
                float domain_size_y,
                float domain_size_z,
                float mass_maximum,
                float time_interval,
                unsigned int random_seed);

#endif /* #ifndef nbody_particle_h */

