!
! nbody_utility.f90
!

      MODULE nbody_utility

          PUBLIC
          SAVE
          REAL,   PARAMETER :: default_domain_size_x          = 1.0e+18 !! m
          REAL,   PARAMETER :: default_domain_size_y          = 1.0e+18 !! m
          REAL,   PARAMETER :: default_domain_size_z          = 1.0e+18 !! m
          REAL,   PARAMETER :: default_mass_maximum           = 1.0e+18 !! kg
          REAL,   PARAMETER :: default_time_interval          = 1.0e+18 !! s
          INTEGER,PARAMETER :: default_number_of_particles    = 1000
          INTEGER,PARAMETER :: default_number_of_timesteps    = 100
          INTEGER,PARAMETER :: default_timesteps_between_outputs =   &
     &                             default_number_of_timesteps
          INTEGER,PARAMETER :: default_random_seed_value      = 12345
          INTEGER,PARAMETER :: default_string_length          = 1000
          CHARACTER (LEN=default_string_length),PARAMETER ::         &
     &        default_base_filename      = "nbody"
          CHARACTER (LEN=default_string_length),PARAMETER ::         &
     &        default_arguments_filename = "nbody_input.txt"

          CHARACTER (LEN=default_string_length) :: base_filename
          REAL    :: mass_maximum
          REAL    :: domain_size_x, domain_size_y, domain_size_z
          REAL    :: time_interval
          INTEGER :: number_of_particles
          INTEGER :: number_of_timesteps, timesteps_between_outputs
          INTEGER :: random_seed_value

      CONTAINS !! MODULE nbody_utility

!........
!........ Seed the random number generator.
!........
          SUBROUTINE seed_random (random_seed_value)
              IMPLICIT NONE

              INTEGER,INTENT(IN) :: random_seed_value

              INTEGER,DIMENSION(1) :: random_seed_value_array

              random_seed_value_array(1) = random_seed_value
              CALL RANDOM_SEED(PUT = random_seed_value_array)

          END SUBROUTINE seed_random

!........
!........ Returns a uniformly distributed random number between 0 and 1.
!........
          REAL FUNCTION uniform_random_0_to_1 ()
              IMPLICIT NONE

              REAL :: random_value

              CALL RANDOM_NUMBER(random_value)

              uniform_random_0_to_1 = random_value

          END FUNCTION uniform_random_0_to_1

!........
!........ Shut down the program cleanly after a failure.
!........
          SUBROUTINE die_cleanly ()
              IMPLICIT NONE

              STOP
          END SUBROUTINE die_cleanly

      END MODULE nbody_utility

